dhtmlxScheduler mit Svelte

Diese Anleitung setzt grundlegende Kenntnisse in Svelte voraus. Falls Sie noch keine Erfahrung mit Svelte haben, finden Sie im Svelte-Handbuch ein hilfreiches Tutorial für den Einstieg.

DHTMLX Scheduler funktioniert gut mit Svelte. Ein funktionierendes Beispiel finden Sie auf GitHub: DHTMLX Scheduler mit Svelte Demo.

Projekt erstellen

Bevor Sie ein neues Projekt anlegen, stellen Sie sicher, dass Vite (optional) und Node.js installiert sind.

Um ein Svelte-Projekt mit Vite zu erstellen, führen Sie folgenden Befehl aus:

npm create vite@latest

Weitere Details finden Sie im entsprechenden Artikel.

Abhängigkeiten installieren

Navigieren Sie anschließend in Ihr App-Verzeichnis. Nennen wir das Projekt scheduler-svelte und wählen die Option svelte. Führen Sie dann aus:

cd scheduler-svelte

Installieren Sie danach die Abhängigkeiten und starten Sie die App mit Ihrem bevorzugten Paketmanager:

  • Für yarn:
yarn install
yarn dev
  • Für npm:
npm install
npm run dev

Ihr Svelte-Projekt sollte nun unter http://localhost:5173 laufen.

Scheduler Svelte App läuft

Scheduler erstellen

Um DHTMLX Scheduler hinzuzufügen, stoppen Sie zunächst die App mit Ctrl+C im Terminal. Installieren Sie anschließend das Scheduler-Paket.

Schritt 1. Paketinstallation

PRO-Versionen der Bibliothek sind über npm/yarn aus unserem privaten Repository verfügbar. Folgen Sie dieser Anleitung, um Zugriff zu erhalten.

Sobald Sie die Evaluierungsversion haben, installieren Sie sie mit:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

Alternativ, da das Zip-Paket der Bibliothek als npm-Modul strukturiert ist, können Sie es auch aus einem lokalen Ordner installieren.

Schritt 2. Komponentenerstellung

Erstellen Sie eine neue Svelte-Komponente, um den Scheduler in Ihre App einzubinden. Legen Sie im src/-Verzeichnis eine Datei mit dem Namen Scheduler.svelte an.

Import der Quell-Dateien

Öffnen Sie Scheduler.svelte und importieren Sie die Scheduler-Dateien. Je nach Installationsmethode:

  • Bei Installation aus einem lokalen Ordner sehen die Imports so aus:

Scheduler.svelte

import { Scheduler } from "dhtmlx-scheduler";
import "dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • Bei Verwendung der Trial-Version sollten die Imports wie folgt aussehen:

Scheduler.svelte

import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

Diese Anleitung verwendet die trial-Version.

Container setzen und Scheduler hinzufügen

Um den Scheduler anzuzeigen, definieren Sie ein Containerelement, in dem er gerendert wird. Der folgende Code zeigt, wie das geht:

Scheduler.svelte

<script>
    import { onMount } from "svelte";
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.init(container, new Date(2023, 9, 6), "week");
 
        return () => scheduler.destructor();
    });
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

Damit der Scheduler-Container den gesamten Body ausfüllt, entfernen Sie die Standard-Styles aus app.css in src/ und fügen Sie Folgendes hinzu:

src/app.css

body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Schritt 3. Scheduler in die App einbinden

Fügen Sie als Nächstes die Scheduler-Komponente in Ihre App ein. Öffnen Sie src/App.svelte und ersetzen Sie den Standardinhalt durch:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
</script>   <Scheduler/>

Wenn Sie die App starten, sollte ein leerer Scheduler auf der Seite erscheinen:

Scheduler Svelte Init

Schritt 4. Daten bereitstellen

Um Termine anzuzeigen, müssen Sie dem Scheduler Daten bereitstellen. Erstellen Sie eine Datei data.js in src/ und fügen Sie Beispieldaten hinzu:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

Übergeben Sie diese Daten dann als Prop an die Scheduler-Komponente in App.svelte:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
  import { getData } from "./data.js";
</script>   <Scheduler data={getData()} />

Verwenden Sie in Scheduler.svelte das Prop mit scheduler.parse():

Scheduler.svelte

<script>
    import { onMount } from "svelte";
 
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css"
    export let data;  
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace"
        scheduler.init(container, new Date(2024, 5, 10), "week");
 
        return () => scheduler.destructor();
    });
 
    $: scheduler?.parse(data);
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

Nach dem Neuladen der App wird der Scheduler mit Terminen angezeigt:

Scheduler Svelte Events

Schritt 5. Daten speichern

Um Änderungen im Scheduler zu verarbeiten, verwenden Sie den dataProcessor-Handler, der die Kommunikation mit einem Server-Backend ermöglicht. Der Handler kann eine Funktion oder ein Router-Objekt sein. dhtmlxScheduler unterstützt Promise-Rückgaben und wartet daher korrekt auf abgeschlossene Aktionen.

Erstellen Sie einen DataProcessor mit createDataProcessor() und erfassen Sie Änderungen wie folgt:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

Falls Ihr Backend beim Erstellen neuer Einträge die Event-IDs ändert (häufiger Fall), stellen Sie sicher, dass Ihr Promise ein Objekt mit {id: databaseId} oder {tid: databaseId} zurückgibt, damit der Scheduler das Ereignis entsprechend aktualisieren kann. Weitere Informationen finden Sie unter Server Side Integration.

Mit dieser Einrichtung ist Ihr Svelte Scheduler einsatzbereit. Das vollständige Demo finden Sie auf GitHub: svelte-scheduler-demo.

XSS-, CSRF- und SQL-Injection-Angriffe

Beachten Sie, dass der Scheduler selbst keinen Schutz gegen Bedrohungen wie SQL-Injection, XSS oder CSRF bietet. Die Absicherung der Anwendung liegt in der Verantwortung der Backend-Entwickler.

Lesen Sie den Artikel Application Security, um die Schwachstellen der Komponente und empfohlene Sicherheitsmaßnahmen zu verstehen.

Nach oben

dhtmlxScheduler mit React

Diese Anleitung setzt grundlegende Kenntnisse in React voraus. Wenn Sie neu bei React sind, empfiehlt es sich, zunächst die React-Dokumentation für ein einführendes Tutorial zu lesen.

DHTMLX Scheduler funktioniert gut mit React. Ein passendes Beispiel finden Sie auf GitHub: DHTMLX Scheduler mit React Demo.

Erstellen eines Projekts

Stellen Sie vor dem Erstellen Ihres Projekts sicher, dass Node.js installiert ist.

Um ein einfaches React-Projekt zu erstellen, führen Sie folgenden Befehl aus:

npx create-vite my-react-scheduler-app --template react

Installation der Abhängigkeiten

Navigieren Sie anschließend in Ihr App-Verzeichnis. In diesem Beispiel verwenden wir my-react-scheduler-app:

cd my-react-scheduler-app

Installieren Sie dann die Abhängigkeiten und starten Sie den Entwicklungsserver mit dem bevorzugten Paketmanager:

  • Mit yarn:
yarn install
yarn dev
  • Mit npm:
npm install
npm run dev

Ihr React-Projekt sollte nun unter http://localhost:5173 laufen.

Scheduler React app running

Scheduler erstellen

Um den DHTMLX Scheduler hinzuzufügen, stoppen Sie zunächst die App mit Strg+C in der Kommandozeile. Installieren Sie danach das Scheduler-Paket.

Schritt 1. Paketinstallation

Die PRO-Versionen der Bibliothek sind über npm/yarn aus unserem privaten Repository verfügbar. Bitte folgen Sie dieser Anleitung, um Zugriff zu erhalten.

Sobald Sie die Evaluierungsversion des Schedulers haben, installieren Sie sie mit einem der folgenden Befehle:

  • Mit npm:
npm install @dhx/trial-scheduler
  • Mit yarn:
yarn add @dhx/trial-scheduler

Alternativ können Sie das Paket auch aus einem lokalen Ordner installieren, da das ZIP-Paket der Bibliothek als npm-Modul strukturiert ist.

Schritt 2. Komponentenerstellung

Erstellen Sie als Nächstes eine React-Komponente, um den Scheduler zu Ihrer App hinzuzufügen. Legen Sie einen Ordner src/components/Scheduler an und erstellen Sie darin die Dateien: Scheduler.jsx, Scheduler.css und index.js.

Beginnen Sie mit Scheduler.css und fügen Sie folgende Styles für den scheduler-container hinzu:

src/components/Scheduler/Scheduler.css

.scheduler-container {
    height: 100vh;
    width: 100vw;
}

Damit der Scheduler-Container den gesamten Body ausfüllt, entfernen Sie die Standard-Styles aus App.css im src-Ordner und fügen Sie Folgendes hinzu:

#root {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Legen Sie dann die Datei index.js mit folgendem Inhalt an:

src/components/Scheduler/index.js

import Scheduler from './Scheduler';
import './Scheduler.css';
export default Scheduler;

Importieren der Quell-Dateien

Öffnen Sie Scheduler.jsx und importieren Sie die Scheduler-Quell-Dateien. Je nachdem, wie Sie das Paket installiert haben, sehen die Imports so aus:

  • Wenn aus einem lokalen Ordner installiert:

Scheduler.jsx

import { Scheduler } from 'dhtmlx-scheduler';
import 'dhtmlx-scheduler/codebase/dhtmlxscheduler.css';
  • Bei Verwendung der Trial-Version:

Scheduler.jsx

import { Scheduler } from '@dhx/trial-scheduler';
import '@dhx/trial-scheduler/codebase/dhtmlxscheduler.css';

In diesem Tutorial wird die Trial-Version verwendet.

Container setzen und Scheduler hinzufügen

Um den Scheduler auf der Seite anzuzeigen, richten Sie einen Container ein. Erstellen Sie Scheduler.jsx mit folgendem Code:

src/components/Scheduler/Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView( ) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

Schritt 3. Scheduler zur App hinzufügen

Fügen Sie nun die Scheduler-Komponente zu Ihrer App hinzu. Öffnen Sie src/App.jsx und ersetzen Sie den Standardinhalt durch:

src/App.jsx

import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler/>
        </div>
    );
}
export default App;

Wenn Sie die App erneut starten, sollte ein leerer Scheduler auf der Seite erscheinen:

Scheduler React init

Schritt 4. Daten bereitstellen

Um Events im Scheduler anzuzeigen, stellen Sie einen Datensatz bereit. Erstellen Sie data.js im src/-Verzeichnis und fügen Sie einige Events hinzu:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

Geben Sie diese Daten dann als Props an die Scheduler-Komponente in App.jsx weiter:

App.jsx

import { getData } from "./data.js";
import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler events={getData()}/>
        </div>
    );
}
export default App;

Verwenden Sie die Props in der scheduler.parse()-Methode innerhalb der Scheduler-Komponente:

Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView({events}) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        scheduler.parse(events);
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

Wenn Sie die App-Seite jetzt neu laden, wird der Scheduler mit geladenen Events angezeigt:

Scheduler React events

Schritt 5. Daten speichern

Um Änderungen im Scheduler zu verarbeiten, können Sie den dataProcessor-Handler verwenden. Damit kann die Kommunikation mit Ihrem Server-Backend erfolgen. Der Handler kann eine Funktion oder ein Router-Objekt sein. dhtmlxScheduler unterstützt Promise-Antworten vom Handler, sodass Aktionen korrekt verarbeitet werden.

Erstellen Sie einen DataProcessor mit createDataProcessor() und erfassen Sie Änderungen wie folgt:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

Wenn Ihr Backend nach dem Erstellen eines neuen Eintrags die Event-ID ändert (was üblich ist), stellen Sie sicher, dass Ihr Promise ein Objekt mit {id: databaseId} oder {tid: databaseId} zurückgibt. So kann der Scheduler den Datensatz mit der neuen Datenbank-ID aktualisieren. Weitere Details finden Sie unter server side integration.

Damit ist Ihre React-Scheduler-Integration abgeschlossen. Sie können das vollständige Demo auf GitHub erkunden: DHTMLX react-scheduler-demo.

XSS-, CSRF- und SQL-Injection-Angriffe

Beachten Sie, dass der Scheduler selbst keinen Schutz gegen Bedrohungen wie SQL-Injections, XSS oder CSRF-Angriffe bietet. Die Absicherung Ihrer Anwendung gegen diese Risiken liegt in der Verantwortung der Backend-Entwickler.

Lesen Sie den Artikel Application Security, um mehr über häufige Schwachstellen und Möglichkeiten zur Verbesserung der Sicherheit Ihrer App zu erfahren.

Nach oben

dhtmlxScheduler mit Angular

Diese Anleitung setzt voraus, dass Sie ein grundlegendes Verständnis von Angular-Konzepten und -Mustern haben. Falls nicht, empfiehlt es sich, die Angular-Dokumentation für ein einsteigerfreundliches Tutorial zu lesen.

DHTMLX Scheduler funktioniert reibungslos mit Angular. Ein praktisches Beispiel finden Sie auf GitHub: DHTMLX Scheduler mit Angular Demo.

Erstellen eines Projekts

Stellen Sie vor dem Start eines neuen Projekts sicher, dass Angular CLI und Node.js installiert sind. Führen Sie dann folgenden Befehl aus:

ng new my-angular-scheduler-app

Dieser Befehl richtet alle benötigten Tools und Abhängigkeiten ein, sodass keine weiteren Schritte erforderlich sind.

Installation der Abhängigkeiten

Navigieren Sie anschließend in den App-Ordner:

cd my-angular-scheduler-app

Starten Sie die App mit einem der folgenden Befehle:

yarn start

oder

npm start

Die App sollte nun unter http://localhost:4200 erreichbar sein.

Scheduler mit Angular

Scheduler erstellen

Um den DHTMLX Scheduler hinzuzufügen, stoppen Sie zunächst die laufende App mit Strg+C im Terminal. Installieren Sie dann das Scheduler-Paket.

Schritt 1. Paketinstallation

PRO-Versionen der Bibliothek sind per npm/yarn aus unserem privaten Repository verfügbar. Folgen Sie dieser Anleitung, um Zugriff zu erhalten.

Sobald Sie die Evaluierungsversion haben, installieren Sie sie mit:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

Alternativ, da das Zip-Paket der Bibliothek als npm-Modul strukturiert ist, können Sie es auch aus einem lokalen Ordner installieren.

Schritt 2. Komponentenerstellung

Erstellen Sie eine neue Komponente zur Integration des Schedulers. Legen Sie im Verzeichnis src/app/ einen scheduler-Ordner an und fügen Sie folgende Dateien hinzu: scheduler.component.ts, scheduler.component.css und scheduler.component.html.

Fügen Sie in scheduler.component.html diese Vorlage für den Scheduler ein:

scheduler/scheduler.component.html

<div #scheduler_here class="dhx_cal_container" style="width: 100%; height:100vh">
   <div class="dhx_cal_navline">
       <div class="dhx_cal_prev_button"></div>
       <div class="dhx_cal_next_button"></div>
       <div class="dhx_cal_today_button"></div>
       <div class="dhx_cal_date"></div>
       <div class="dhx_cal_tab" data-tab="day"></div>
       <div class="dhx_cal_tab" data-tab="week"></div>
       <div class="dhx_cal_tab" data-tab="month"></div>
   </div>
   <div class="dhx_cal_header"></div>
   <div class="dhx_cal_data"></div>
</div>

Deklarieren Sie die Scheduler-Styles separat in scheduler.component.css. Hier ein einfaches Beispiel:

scheduler/scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
:host {
   display: block;
   position: relative;
   height: 100%;
   width: 100%;
}

Um sicherzustellen, dass der Scheduler-Container den gesamten Body ausfüllt, fügen Sie diese Styles zu styles.css im src-Ordner hinzu:

src/styles.css

html,
body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Importieren der Quelldateien

Öffnen Sie scheduler.component.ts und scheduler.component.css, um die Scheduler-Quelldateien zu importieren. Je nach Installationsmethode:

  • Bei Installation aus einem lokalen Ordner sehen die Importe so aus:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from 'dhtmlx-scheduler';

scheduler.component.css

@import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • Bei Verwendung der Trial-Version sollten die Importe so aussehen:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from '@dhx/trial-scheduler';

scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

In diesem Tutorial wird die trial-Version verwendet.

Container setzen und Scheduler hinzufügen

Um den Scheduler auf der Seite anzuzeigen, muss der Container gesetzt werden, in dem er gerendert wird. Hier der Code:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

Hier initialisiert der ngOnInit()-Lebenszyklus-Hook den Scheduler, und ngOnDestroy() ruft scheduler.destructor() auf, um beim Zerstören der Komponente aufzuräumen.

Schritt 3. Scheduler in die App einfügen

Ersetzen Sie als Nächstes den Standardinhalt durch die Scheduler-Komponente. Öffnen Sie src/app/app.component.ts und aktualisieren Sie die Datei wie folgt:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  template: `<scheduler></scheduler>`,
})
export class AppComponent {
  name = '';
}

Erstellen Sie app.module.ts in src/app/ und binden Sie SchedulerComponent wie folgt ein:

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { SchedulerComponent } from "./scheduler/scheduler.component";
 
@NgModule({
  declarations: [AppComponent, SchedulerComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

Aktualisieren Sie abschließend src/main.ts und ersetzen Sie den Inhalt durch:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

Nachdem Sie die App erneut gestartet haben, sollte ein leerer Scheduler auf der Seite erscheinen.

Scheduler in eine App einfügen

Schritt 4. Daten bereitstellen

Um das Laden von Daten im Angular Scheduler zu ermöglichen, muss ein Event-Service hinzugefügt werden. Zuvor ist es notwendig, das Event-Modell zu definieren.

Um das Event-Modell zu erstellen, verwenden Sie folgenden Befehl:

ng generate class models/event --skip-tests

Fügen Sie in der neu erstellten Datei event.ts im models-Ordner folgenden Code hinzu:

models/event.ts

export class Event {
    id!:  number;
    start_date!: string;
    end_date!: string;
    text!: string;
}

Erstellen Sie als Nächstes einen Event-Service. Dieser Service ist eine Klasse, die für das Verwalten bestimmter Events zuständig ist. In Angular können Services per Dependency Injection eingebunden werden. Sie können Daten, Funktionen oder Features enthalten, die von der Anwendung benötigt werden. Hier wird ein Data-Service erstellt, der dem Scheduler Events bereitstellt.

Um den Event-Service zu generieren, führen Sie aus:

ng generate service services/event --flat --skip-tests

Fügen Sie in der neu erstellten Datei event.service.ts im services-Ordner folgenden Code ein:

services/event.service.ts

import { Injectable } from '@angular/core';
import { Event } from "../models/event";
 
@Injectable()
export class EventService {
    get(): Promise<Event[]>{
        return Promise.resolve([
            { id: 1, start_date: "2023-05-16 09:00", end_date: "2023-05-16 13:00", 
                text: "Event 1" },
            { id: 2, start_date: "2023-05-18 10:00", end_date: "2023-05-18 14:00", 
                text: "Event 2" },
        ]);
    }
}

Der @Injectable()-Decorator kennzeichnet diesen Service als für die Injektion verfügbar. Dieser Service wird später in die Komponente eingebunden.

Aktuell gibt die get()-Methode ein aufgelöstes Promise mit fest kodierten Events zurück. Es ist auch möglich, Daten vom Server zu laden und ein Promise zurückzugeben. Die Scheduler-Komponente wird EventService nutzen, um Events zu erhalten. Um dies einzurichten, fügen Sie EventService in scheduler.component.ts ein:

scheduler.component.ts

import {EventService} from "../services/event.service";

Geben Sie dann EventService als Provider im @Component-Decorator an:

scheduler.component.ts

@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})

Dies stellt sicher, dass bei jeder Erstellung einer SchedulerComponent eine neue Instanz des Service bereitgestellt wird. Um den Service in die Komponente zu injizieren, fügen Sie diesen Konstruktor in die SchedulerComponent-Klasse ein:

scheduler.component.ts

constructor(private eventService: EventService){}

Aktualisieren Sie die ngOnInit()-Methode, um:

  • das Datumsformat für das Laden der Events festzulegen (hier wird das XML-Format verwendet)
  • den Service aufzurufen, um Events zu erhalten und auf die Daten zu warten, bevor sie an den Scheduler übergeben werden

scheduler.component.ts

scheduler.config.date_format = "%Y-%m-%d %H:%i";
scheduler.init(this.schedulerContainer.nativeElement, new Date(2024, 9, 7));
this.eventService.get()
    .then((data) => {
         scheduler.parse(data);
    });

Die vollständige Datei scheduler.component.ts sieht dann so aus:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
import {EventService} from "../services/event.service";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ['scheduler.component.css'],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
  constructor(private eventService: EventService) { }
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.config.date_format = "%Y-%m-%d %H:%i";
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this.eventService.get().then((data) => {scheduler.parse(data);});
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

Nach dem erneuten Öffnen der App-Seite sollte der Scheduler die Events anzeigen.

Scheduler mit Angular-Events

Schritt 5. Daten speichern

Um Änderungen, die im Scheduler vorgenommen werden, nachzuverfolgen, kann ein dataProcessor-Handler verwendet werden, um mit dem Backend zu kommunizieren. Dieser Handler kann als Funktion oder als Router-Objekt definiert werden. dhtmlxScheduler unterstützt Promise-Antworten vom Handler, was eine ordnungsgemäße Verarbeitung der Aktionen gewährleistet.

Ein DataProcessor kann mit der createDataProcessor()-API-Methode erstellt werden, um Änderungen zu erfassen, wie im folgenden Beispiel:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

Falls der Service die Event-ID nach dem Erstellen eines neuen Eintrags ändert (was häufig der Fall ist), sollte das Promise ein Objekt mit {id: databaseId} oder {tid: databaseId} zurückgeben. Dadurch kann der Scheduler den Eintrag mit der neuen Datenbank-ID aktualisieren.

Weitere Informationen zur serverseitigen Integration finden Sie hier.

Der Angular Scheduler ist nun eingerichtet. Sie können sich gerne das vollständige Demo auf GitHub ansehen.

XSS-, CSRF- und SQL-Injection-Angriffe

Beachten Sie, dass der Scheduler selbst keinen Schutz vor Bedrohungen wie SQL-Injection, XSS oder CSRF-Angriffen bietet. Die Sicherheit der Anwendung liegt in der Verantwortung der Backend-Entwickler.

Weitere Informationen zu möglichen Schwachstellen und empfohlenen Sicherheitspraktiken finden Sie im Artikel Application Security.

Nach oben

dhtmlxScheduler mit Vue.js

Diese Anleitung setzt grundlegende Kenntnisse von Vue Konzepten und Arbeitsweisen voraus. Falls Sie eine Auffrischung benötigen, bietet die Vue 3 Dokumentation ein hilfreiches Einstiegs-Tutorial.

DHTMLX Scheduler funktioniert reibungslos mit Vue. Ein passendes Beispiel finden Sie auf GitHub: DHTMLX Scheduler mit Vue Demo.

Projekt erstellen

Bevor Sie ein neues Projekt starten, stellen Sie sicher, dass Node.js installiert ist.

Um ein Vue-Projekt zu erstellen, führen Sie diesen Befehl aus:

npm create vue@latest

Damit wird create-vue, das offizielle Vue-Projekt-Scaffolding-Tool, installiert und ausgeführt. Weitere Details finden Sie im Vue.js Quick Start.

Installation der Abhängigkeiten

Navigieren Sie anschließend in das App-Verzeichnis. Für diese Anleitung nennen wir das Projekt scheduler-vue und führen aus:

cd scheduler-vue

Installieren Sie dann die Abhängigkeiten und starten Sie den Entwicklungsserver mit einem Paketmanager:

  • Für yarn, führen Sie aus:
yarn install
yarn dev
  • Für npm, führen Sie aus:
npm install
npm run dev

Ihr Vue-Projekt sollte nun unter http://localhost:5173 erreichbar sein.

Scheduler Vue.js App läuft

Scheduler erstellen

Bevor Sie den Scheduler hinzufügen, stoppen Sie die laufende App, indem Sie Strg+C im Terminal drücken. Danach fahren Sie mit der Installation des Scheduler-Pakets fort.

Schritt 1. Paketinstallation

Die PRO-Versionen der Bibliothek sind über npm/yarn aus unserem privaten Repository verfügbar. Folgen Sie dieser Anleitung, um Zugriff zu erhalten.

Sobald Sie die Evaluierungsversion des Schedulers haben, installieren Sie diese mit:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

Alternativ, da das Bibliotheks-Zip-Paket als npm-Modul strukturiert ist, können Sie es auch aus einem lokalen Ordner installieren.

Schritt 2. Komponentenerstellung

Erstellen Sie eine Vue-Komponente, um den Scheduler in Ihre App zu integrieren. Fügen Sie eine neue Datei mit dem Namen Scheduler.vue im Verzeichnis src/components/ hinzu.

Quell-Dateien importieren

Öffnen Sie Scheduler.vue und importieren Sie die Scheduler-Quell-Dateien. Abhängig von Ihrer Installationsmethode:

  • Bei Installation aus einem lokalen Ordner sehen die Importe so aus:

Scheduler.vue

import { Scheduler } from "dhtmlx-scheduler";<style>
  @import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
</style>
  • Für die Trial-Version sollten die Importe so aussehen:

Scheduler.vue

import { Scheduler } from "@dhx/trial-scheduler";<style>
  @import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
</style>

Dieses Tutorial verwendet die trial-Version des Schedulers.

Container setzen und Scheduler hinzufügen

Um den Scheduler auf der Seite anzuzeigen, setzen Sie das Container-Element. Hier ist der relevante Code:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 9, 6), "week");
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

Damit der Scheduler-Container den gesamten Body ausfüllt, entfernen Sie die Standard-Styles aus main.css im Verzeichnis src/assets und ersetzen Sie sie durch:

src/assets/main.css

#app {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

Schritt 3. Scheduler zur App hinzufügen

Fügen Sie als Nächstes die Scheduler-Komponente zur App hinzu. Öffnen Sie src/App.vue und ersetzen Sie den Standardinhalt durch:

src/App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
 
export default {
  components: { Scheduler },
};
</script>   <template> <Scheduler/> </template>

Wenn Sie die App jetzt starten, sollte ein leerer Scheduler auf der Seite erscheinen:

Scheduler Vue Init

Schritt 4. Daten bereitstellen

Um Ereignisse im Scheduler anzuzeigen, müssen Sie Daten bereitstellen. Erstellen Sie eine Datei namens data.js im Verzeichnis src/ und fügen Sie einige Beispiel-Ereignisse hinzu:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

Übergeben Sie diese Daten als Props an die Scheduler-Komponente in App.vue:

App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
import { getData } from "./data";
 
export default {
  components: { Scheduler },
  data() {
    return {
      events: getData(),
    };
  },
};
</script>   <template> <Scheduler :events="events" /> </template>

Verwenden Sie dann die Props in der Methode scheduler.parse() innerhalb der Scheduler-Komponente:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  props: ["events"],
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 5, 10), "week");
    scheduler.parse(this.events);
 
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

Nach dem Neuladen der App-Seite wird der Scheduler nun mit Ereignissen angezeigt:

Scheduler Vue Ereignisse

Schritt 5. Daten speichern

Um Änderungen im Scheduler zu verfolgen, können Sie den dataProcessor Handler verwenden, der die Kommunikation mit dem Server-Backend erleichtert. Der Handler kann als Funktion oder als Router-Objekt definiert werden. dhtmlxScheduler unterstützt Promise-Antworten vom Handler, sodass Aktionen korrekt verarbeitet werden.

Erstellen Sie einen DataProcessor mit der createDataProcessor() API-Methode und erfassen Sie Änderungen wie folgt:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

Falls Ihr Backend die Event-ID nach dem Erstellen eines neuen Datensatzes ändert (was häufig vorkommt), stellen Sie sicher, dass Ihr Promise ein Objekt mit {id: databaseId} oder {tid: databaseId} zurückgibt. Dadurch kann der Scheduler den Datensatz mit der neuen Datenbank-ID aktualisieren. Weitere Informationen finden Sie unter Server Side Integration.

Damit ist Ihr Vue Scheduler Setup abgeschlossen. Sie können die vollständige Demo auf GitHub erkunden: https://github.com/DHTMLX/vue-scheduler-demo.

XSS-, CSRF- und SQL-Injection-Angriffe

Beachten Sie, dass der Scheduler selbst keinen Schutz vor Bedrohungen wie SQL-Injection, XSS oder CSRF-Angriffen bietet. Die Sicherstellung der Anwendungssicherheit liegt in der Verantwortung der Entwickler, insbesondere bei der Backend-Implementierung.

Lesen Sie den Artikel Application Security, um die Schwachstellen der Komponente zu verstehen und Maßnahmen zur Erhöhung der Sicherheit Ihrer Anwendung zu ergreifen.

Nach oben